<?php
namespace Ig\IgQrcode\Utility;

class QrCodeUtility implements \TYPO3\CMS\Core\SingletonInterface
{
    const PNG = 'PNG';
    const SVG = 'SVG';
    const EPS = 'EPS';
    const PDF = 'PDF';
    
    public static function render(string $content, string $imageType='SVG', array $arguments = [])
    {
        $pipes = [];
        $descriptorspec = [
            0 => ['pipe', 'r'],  // STDIN ist eine Pipe, von der das Child liest
            1 => ['pipe', 'w']
        ];

        $additionalArguments = [];
        $additionalArgumentsString = '';
        if (!empty($arguments)) {
            foreach ($arguments as $name => $value) {
                if (in_array($name, ['foreground', 'background'])) {
                    $additionalArguments[] = '--' . $name . '=' . escapeshellarg($value);
                }
            }
            $additionalArgumentsString = implode(' ',  $additionalArguments);
        }
        //echo('qrencode -s 8 --type=' . $imageType . ' ' . $additionalArgumentsString . ' -o -');exit(0);
        if($imageType==self::PDF) {
            $fp=proc_open('qrencode -s 8 --type=EPS ' . $additionalArgumentsString . ' -o - |epstopdf -f -o=- ',  $descriptorspec, $pipes);
        } else {
            $fp=proc_open('qrencode -s 8 --type=' . $imageType . ' ' . $additionalArgumentsString . ' -o -',  $descriptorspec, $pipes);
        }
        fwrite($pipes[0],  $content );
        fclose($pipes[0]);
        $imageContent =  stream_get_contents($pipes[1]);
        return $imageContent;
    }
    
    
}