<?php
namespace Ig\IgQrcode\Widgets;

use Ig\IgQrcode\Widgets\Provider\TableProvider;
use TYPO3\CMS\Dashboard\Widgets\ButtonProviderInterface;
use TYPO3\CMS\Dashboard\Widgets\WidgetConfigurationInterface;
use TYPO3\CMS\Dashboard\Widgets\WidgetInterface;
use TYPO3\CMS\Fluid\View\StandaloneView;

class TableWidget implements WidgetInterface
{
    /**
     * @var WidgetConfigurationInterface
     */
    private $configuration;

    /**
     * @var StandaloneView
     */
    private $view;

    /**
     * @var TableProvider
     */
    private $dataProvider;

    /**
     * @var array
     */
    private $options;

    /**
     * @var ButtonProviderInterface|null
     */
    private $buttonProvider;

    public function __construct(
        WidgetConfigurationInterface $configuration,
        TableProvider $dataProvider,
        StandaloneView $view,
        ButtonProviderInterface $buttonProvider = null,
        array $options = []
    ) {
        $this->configuration = $configuration;
        $this->view = $view;
        $this->dataProvider = $dataProvider;
        $this->options = $options;
        $this->buttonProvider = $buttonProvider;
    }

    public function renderWidgetContent(): string
    {
        $this->view->setTemplate($this->options['template']);
        $findBy = 'findBy' . ucfirst($this->options['findBy']);
        if (method_exists($this->dataProvider, $findBy)) {
            $this->view->assignMultiple([
                'columns' => array_map('trim', explode(',', $this->options['columns'])),
                'records' => $this->dataProvider->$findBy(),
                'options' => $this->options,
                'configuration' => $this->configuration,
            ]);
            return $this->view->render();
        }
    }
    public function getOptions(): array
    {
        return $this->options;
    }

}
